
#property copyright "Copyright  2009, Victor Chebotariov"
#property link      "http://www.chebotariov.com"

#define magic      1052009
#define MAGICNUM  14052009
//+------------------------------------------------------------------+
//|                                                           SU.mq4 |
//|                                        Copyright  2009, murnail |
//|                                         mailto:murnail@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, murnail"
#property link      "mailto:murnail@yandex.ru"

//  I_TRADER    ,     . ...


//---- input parameters
extern double OpenT      = 50;
extern double Lot        = 0.6;
extern double Lot2       = 0.5;
extern double TakeProfit = 410;
extern int    StopLoss   = 150; 
extern int    N_MaxBar   = 1000;
extern double Delta      = 50000;
extern string   t=" ";
extern int period = 580;
extern int L1     = 100;
extern int L2     = 240;
extern int L3     = 300;
extern int L4     = 250;
extern int L5     = 270;
extern int L6     = 280;

extern int slippage=3;

//extern int TakeProfit_L = 70; //    
//extern int StopLoss_L = 147;  //    
//extern int TakeProfit_S = 50; //    
//extern int StopLoss_S = 257;  //    
//+------------------------------------------------------------------+
//| CCI_TRADER expert start function                                 |
//+------------------------------------------------------------------+

//********************
//      
int CalcNumLongs()
{
   int nLongs = 0;
   for (int i = 0; i < OrdersTotal(); i++) {
      int resL = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (resL == 0) {
         Print ("   : ", GetLastError()); 
         return;
      }
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGICNUM 
            && OrderType() == OP_BUY) nLongs++;
   }
   return (nLongs);
  } 
//      
int CalcNumShorts()
{
   int nShorts = 0;
   for (int iS = 0; iS < OrdersTotal(); iS++) {
      int resS = OrderSelect(iS, SELECT_BY_POS, MODE_TRADES);
      if (resS == 0) {
         Print ("   : ", GetLastError()); 
         return;
      }
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGICNUM 
            && OrderType() == OP_SELL) nShorts++;
   }
   return (nShorts);
}  
   
//   
void CheckForOpen()
{  
   bool found = false;
   //       
   for (int i = OrdersTotal() - 1; i >= 0; i--) {
      int res = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (res == 0) {
         Print ("   : ", GetLastError()); 
         return;
      }
      if (OrderMagicNumber() == MAGICNUM && 
            OrderSymbol() == Symbol() && OrderType() == OP_BUY) {                                      
         found = true; //...          
         break;
   //        
      }
      if (OrderMagicNumber() == MAGICNUM && 
            OrderSymbol() == Symbol() && OrderType() == OP_SELL) {                                      
         found = true; //...           
         break;
      }
   if (!found) {
      Print (":        : ", GetLastError()); 
      return;   
    }   
   //     OpenT,    
   if (OrderProfit() <= OpenT)
      Print ("  ,   ");
    { 
      double Min = Close[ArrayMinimum(Close, N_MaxBar, 1)]; 
      Print (Bid, " ", Min - Delta * Point);
      res = OrderSend (Symbol(), OP_BUY, Lot, Ask, 3, Min - Delta * Point, Ask + TakeProfit * Point, "", MAGICNUM, 0, Blue);
      if (res == 0) {         
         Print ("    : ",GetLastError()); 
         return;
      }        
    if (!found) {
     Print (":        : ", GetLastError()); 
      return;   
    }
  }  
} 
 //     OpenT,    
   if (OrderProfit() <= OpenT) {
      Print (OrderProfit());
      double Max = Close[ArrayMaximum(Close, N_MaxBar, 1)]; 
      Print (Bid, " ", Max + Delta * Point);
      res = OrderSend (Symbol(), OP_SELL, Lot, Bid, 3, Max + Delta * Point, Bid - TakeProfit * Point, "", MAGICNUM, 0, Red);
      if (res == 0) {         
         Print ("    : ",GetLastError()); 
         return;
   }
   if (!found) {
      Print (":        : ", GetLastError()); 
      return;   
      }         
   }        
}

//********************
// 
int start()
  {
//----
   double val = iCCI(NULL ,0,period,PRICE_TYPICAL,0);
   int ticket, cnt, total=OrdersTotal();     
   if(total<1)
      {
         if(val>L1)
            {
               ticket=OrderSend(Symbol(),OP_BUY,Lot2,Ask,slippage,Ask-StopLoss*Point,
                      Ask+TakeProfit*Point,"CCI_TRADER",magic,0,Green);
               if(ticket>0)
                  {
                     if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
//*****************
                      {
   //    
   if (Bars < N_MaxBar || IsTradeAllowed() == false) return;
         Print ("    "); 
   //   ,    
   if (CalcNumLongs() == 0) {
      double Min = Close[ArrayMinimum(Close, N_MaxBar, 1)]; 
      Print (Bid, " ", Min - Delta * Point);
      int resL = OrderSend (Symbol(), OP_BUY, Lot, Ask, 3, Min - Delta * Point, Ask + TakeProfit * Point, "", MAGICNUM, 0, Blue);
          Print ("  ");      
      if (resL == 0) {         
         Print ("    : ",GetLastError()); 
         return;
      }           
   }
   else CheckForOpen();
   return;
}
//*****************                     
                     
                     
                  }
               else
                  {
                     Print("Error opening BUY order : ",GetLastError());
                     return(0);
                  }
            }
         else if(val<-L2)
            {
               ticket=OrderSend(Symbol(),OP_SELL,Lot2,Bid,slippage,Bid+StopLoss*Point,
                      Bid-TakeProfit*Point,"CCI_TRADER",magic,0,Red);
               if(ticket>0)
                  {
                     if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
//*************
{
   //    
   if (Bars < N_MaxBar || IsTradeAllowed() == false) return;
          Print ("    ");   
   //   ,    
   if (CalcNumShorts() == 0) {
      double Max = Close[ArrayMaximum(Close, N_MaxBar, 1)]; 
      Print (Bid, " ", Max + Delta * Point);
      int resS = OrderSend (Symbol(), OP_SELL, Lot, Bid, 3, Max + Delta * Point, Bid - TakeProfit * Point, "", MAGICNUM, 0, Red);
          Print ("  ");      
      if (resS == 0) {         
         Print ("    : ",GetLastError()); 
         return;
      }      
   }
   else CheckForOpen();
   return;
}
//*************                     
                  }
               else
                  {
                     Print("Error opening SELL order : ",GetLastError());
                     return(0);
                  }
            }
      }
if (OrderMagicNumber()==magic)
         {
         if(OrderType()<=OP_SELL &&   // check for opened position 
            OrderSymbol()==Symbol())  // check for symbol
           {
            if(OrderType()==OP_BUY)   // long position is opened
              {
               // should it be closed?
               if(val<-L3)
                   {
                    OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                    return(0); // exit
                   }
              }
            else // go to short position
              {
               // should it be closed?
               if(val>L4)
                 {
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
                  return(0); // exit
                 }
              }
           }
        }
for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(val<-L5)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
           }
         else // go to short position
           {
            // should it be closed?
            if(val>L6)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
           }
        }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+